Commit a18f2845 authored by Florian Westphal's avatar Florian Westphal Committed by Jakub Kicinski

selftests: netfilter: nft_flowtable.sh: shellcheck cleanups

no functional changes intended except that test will now SKIP in
case kernel lacks bridge support and initial rule load failure provides
nft version information.
Signed-off-by: default avatarFlorian Westphal <fw@strlen.de>
Link: https://lore.kernel.org/r/20240423130604.7013-6-fw@strlen.deSigned-off-by: default avatarJakub Kicinski <kuba@kernel.org>
parent f84ab634
...@@ -37,17 +37,17 @@ cleanup() { ...@@ -37,17 +37,17 @@ cleanup() {
rm -f "$nsin" "$ns1out" "$ns2out" rm -f "$nsin" "$ns1out" "$ns2out"
[ $log_netns -eq 0 ] && sysctl -q net.netfilter.nf_log_all_netns=$log_netns [ "$log_netns" -eq 0 ] && sysctl -q net.netfilter.nf_log_all_netns="$log_netns"
} }
trap cleanup EXIT trap cleanup EXIT
sysctl -q net.netfilter.nf_log_all_netns=1 sysctl -q net.netfilter.nf_log_all_netns=1
ip link add veth0 netns $nsr1 type veth peer name eth0 netns $ns1 ip link add veth0 netns "$nsr1" type veth peer name eth0 netns "$ns1"
ip link add veth1 netns $nsr1 type veth peer name veth0 netns $nsr2 ip link add veth1 netns "$nsr1" type veth peer name veth0 netns "$nsr2"
ip link add veth1 netns $nsr2 type veth peer name eth0 netns $ns2 ip link add veth1 netns "$nsr2" type veth peer name eth0 netns "$ns2"
for dev in veth0 veth1; do for dev in veth0 veth1; do
ip -net "$nsr1" link set "$dev" up ip -net "$nsr1" link set "$dev" up
...@@ -90,13 +90,13 @@ do ...@@ -90,13 +90,13 @@ do
esac esac
done done
if ! ip -net $nsr1 link set veth0 mtu $omtu; then if ! ip -net "$nsr1" link set veth0 mtu "$omtu"; then
exit 1 exit 1
fi fi
ip -net $ns1 link set eth0 mtu $omtu ip -net "$ns1" link set eth0 mtu "$omtu"
if ! ip -net $nsr2 link set veth1 mtu $rmtu; then if ! ip -net "$nsr2" link set veth1 mtu "$rmtu"; then
exit 1 exit 1
fi fi
...@@ -108,7 +108,7 @@ if ! ip -net "$nsr2" link set veth0 mtu "$lmtu"; then ...@@ -108,7 +108,7 @@ if ! ip -net "$nsr2" link set veth0 mtu "$lmtu"; then
exit 1 exit 1
fi fi
ip -net $ns2 link set eth0 mtu $rmtu ip -net "$ns2" link set eth0 mtu "$rmtu"
# transfer-net between nsr1 and nsr2. # transfer-net between nsr1 and nsr2.
# these addresses are not used for connections. # these addresses are not used for connections.
...@@ -119,35 +119,34 @@ ip -net "$nsr2" addr add 192.168.10.2/24 dev veth0 ...@@ -119,35 +119,34 @@ ip -net "$nsr2" addr add 192.168.10.2/24 dev veth0
ip -net "$nsr2" addr add fee1:2::2/64 dev veth0 nodad ip -net "$nsr2" addr add fee1:2::2/64 dev veth0 nodad
for i in 0 1; do for i in 0 1; do
ip netns exec $nsr1 sysctl net.ipv4.conf.veth$i.forwarding=1 > /dev/null ip netns exec "$nsr1" sysctl net.ipv4.conf.veth$i.forwarding=1 > /dev/null
ip netns exec $nsr2 sysctl net.ipv4.conf.veth$i.forwarding=1 > /dev/null ip netns exec "$nsr2" sysctl net.ipv4.conf.veth$i.forwarding=1 > /dev/null
done done
for ns in $ns1 $ns2;do for ns in "$ns1" "$ns2";do
ip -net $ns link set lo up ip -net "$ns" link set eth0 up
ip -net $ns link set eth0 up
if ! ip netns exec $ns sysctl net.ipv4.tcp_no_metrics_save=1 > /dev/null; then if ! ip netns exec "$ns" sysctl net.ipv4.tcp_no_metrics_save=1 > /dev/null; then
echo "ERROR: Check Originator/Responder values (problem during address addition)" echo "ERROR: Check Originator/Responder values (problem during address addition)"
exit 1 exit 1
fi fi
# don't set ip DF bit for first two tests # don't set ip DF bit for first two tests
ip netns exec $ns sysctl net.ipv4.ip_no_pmtu_disc=1 > /dev/null ip netns exec "$ns" sysctl net.ipv4.ip_no_pmtu_disc=1 > /dev/null
done done
ip -net $ns1 addr add 10.0.1.99/24 dev eth0 ip -net "$ns1" addr add 10.0.1.99/24 dev eth0
ip -net $ns2 addr add 10.0.2.99/24 dev eth0 ip -net "$ns2" addr add 10.0.2.99/24 dev eth0
ip -net $ns1 route add default via 10.0.1.1 ip -net "$ns1" route add default via 10.0.1.1
ip -net $ns2 route add default via 10.0.2.1 ip -net "$ns2" route add default via 10.0.2.1
ip -net $ns1 addr add dead:1::99/64 dev eth0 nodad ip -net "$ns1" addr add dead:1::99/64 dev eth0 nodad
ip -net $ns2 addr add dead:2::99/64 dev eth0 nodad ip -net "$ns2" addr add dead:2::99/64 dev eth0 nodad
ip -net $ns1 route add default via dead:1::1 ip -net "$ns1" route add default via dead:1::1
ip -net $ns2 route add default via dead:2::1 ip -net "$ns2" route add default via dead:2::1
ip -net $nsr1 route add default via 192.168.10.2 ip -net "$nsr1" route add default via 192.168.10.2
ip -net $nsr2 route add default via 192.168.10.1 ip -net "$nsr2" route add default via 192.168.10.1
ip netns exec $nsr1 nft -f - <<EOF ip netns exec "$nsr1" nft -f - <<EOF
table inet filter { table inet filter {
flowtable f1 { flowtable f1 {
hook ingress priority 0 hook ingress priority 0
...@@ -179,7 +178,7 @@ if [ $? -ne 0 ]; then ...@@ -179,7 +178,7 @@ if [ $? -ne 0 ]; then
exit $ksft_skip exit $ksft_skip
fi fi
ip netns exec $ns2 nft -f - <<EOF ip netns exec "$ns2" nft -f - <<EOF
table inet filter { table inet filter {
counter ip4dscp0 { } counter ip4dscp0 { }
counter ip4dscp3 { } counter ip4dscp3 { }
...@@ -195,17 +194,18 @@ table inet filter { ...@@ -195,17 +194,18 @@ table inet filter {
EOF EOF
if [ $? -ne 0 ]; then if [ $? -ne 0 ]; then
echo "SKIP: Could not load nft ruleset" echo -n "SKIP: Could not load ruleset: "
nft --version
exit $ksft_skip exit $ksft_skip
fi fi
# test basic connectivity # test basic connectivity
if ! ip netns exec $ns1 ping -c 1 -q 10.0.2.99 > /dev/null; then if ! ip netns exec "$ns1" ping -c 1 -q 10.0.2.99 > /dev/null; then
echo "ERROR: $ns1 cannot reach ns2" 1>&2 echo "ERROR: $ns1 cannot reach ns2" 1>&2
exit 1 exit 1
fi fi
if ! ip netns exec $ns2 ping -c 1 -q 10.0.1.99 > /dev/null; then if ! ip netns exec "$ns2" ping -c 1 -q 10.0.1.99 > /dev/null; then
echo "ERROR: $ns2 cannot reach $ns1" 1>&2 echo "ERROR: $ns2 cannot reach $ns1" 1>&2
exit 1 exit 1
fi fi
...@@ -235,23 +235,27 @@ check_counters() ...@@ -235,23 +235,27 @@ check_counters()
local what=$1 local what=$1
local ok=1 local ok=1
local orig=$(ip netns exec $nsr1 nft reset counter inet filter routed_orig | grep packets) local orig repl
local repl=$(ip netns exec $nsr1 nft reset counter inet filter routed_repl | grep packets) orig=$(ip netns exec "$nsr1" nft reset counter inet filter routed_orig | grep packets)
repl=$(ip netns exec "$nsr1" nft reset counter inet filter routed_repl | grep packets)
local orig_cnt=${orig#*bytes} local orig_cnt=${orig#*bytes}
local repl_cnt=${repl#*bytes} local repl_cnt=${repl#*bytes}
local fs=$(du -sb $nsin) local fs
fs=$(du -sb "$nsin")
local max_orig=${fs%%/*} local max_orig=${fs%%/*}
local max_repl=$((max_orig/4)) local max_repl=$((max_orig/4))
if [ $orig_cnt -gt $max_orig ];then # flowtable fastpath should bypass normal routing one, i.e. the counters in forward hook
# should always be lower than the size of the transmitted file (max_orig).
if [ "$orig_cnt" -gt "$max_orig" ];then
echo "FAIL: $what: original counter $orig_cnt exceeds expected value $max_orig" 1>&2 echo "FAIL: $what: original counter $orig_cnt exceeds expected value $max_orig" 1>&2
ret=1 ret=1
ok=0 ok=0
fi fi
if [ $repl_cnt -gt $max_repl ];then if [ "$repl_cnt" -gt $max_repl ];then
echo "FAIL: $what: reply counter $repl_cnt exceeds expected value $max_repl" 1>&2 echo "FAIL: $what: reply counter $repl_cnt exceeds expected value $max_repl" 1>&2
ret=1 ret=1
ok=0 ok=0
...@@ -267,39 +271,40 @@ check_dscp() ...@@ -267,39 +271,40 @@ check_dscp()
local what=$1 local what=$1
local ok=1 local ok=1
local counter=$(ip netns exec $ns2 nft reset counter inet filter ip4dscp3 | grep packets) local counter
counter=$(ip netns exec "$ns2" nft reset counter inet filter ip4dscp3 | grep packets)
local pc4=${counter%*bytes*} local pc4=${counter%*bytes*}
local pc4=${pc4#*packets} local pc4=${pc4#*packets}
local counter=$(ip netns exec $ns2 nft reset counter inet filter ip4dscp0 | grep packets) counter=$(ip netns exec "$ns2" nft reset counter inet filter ip4dscp0 | grep packets)
local pc4z=${counter%*bytes*} local pc4z=${counter%*bytes*}
local pc4z=${pc4z#*packets} local pc4z=${pc4z#*packets}
case "$what" in case "$what" in
"dscp_none") "dscp_none")
if [ $pc4 -gt 0 ] || [ $pc4z -eq 0 ]; then if [ "$pc4" -gt 0 ] || [ "$pc4z" -eq 0 ]; then
echo "FAIL: dscp counters do not match, expected dscp3 == 0, dscp0 > 0, but got $pc4,$pc4z" 1>&2 echo "FAIL: dscp counters do not match, expected dscp3 == 0, dscp0 > 0, but got $pc4,$pc4z" 1>&2
ret=1 ret=1
ok=0 ok=0
fi fi
;; ;;
"dscp_fwd") "dscp_fwd")
if [ $pc4 -eq 0 ] || [ $pc4z -eq 0 ]; then if [ "$pc4" -eq 0 ] || [ "$pc4z" -eq 0 ]; then
echo "FAIL: dscp counters do not match, expected dscp3 and dscp0 > 0 but got $pc4,$pc4z" 1>&2 echo "FAIL: dscp counters do not match, expected dscp3 and dscp0 > 0 but got $pc4,$pc4z" 1>&2
ret=1 ret=1
ok=0 ok=0
fi fi
;; ;;
"dscp_ingress") "dscp_ingress")
if [ $pc4 -eq 0 ] || [ $pc4z -gt 0 ]; then if [ "$pc4" -eq 0 ] || [ "$pc4z" -gt 0 ]; then
echo "FAIL: dscp counters do not match, expected dscp3 > 0, dscp0 == 0 but got $pc4,$pc4z" 1>&2 echo "FAIL: dscp counters do not match, expected dscp3 > 0, dscp0 == 0 but got $pc4,$pc4z" 1>&2
ret=1 ret=1
ok=0 ok=0
fi fi
;; ;;
"dscp_egress") "dscp_egress")
if [ $pc4 -eq 0 ] || [ $pc4z -gt 0 ]; then if [ "$pc4" -eq 0 ] || [ "$pc4z" -gt 0 ]; then
echo "FAIL: dscp counters do not match, expected dscp3 > 0, dscp0 == 0 but got $pc4,$pc4z" 1>&2 echo "FAIL: dscp counters do not match, expected dscp3 > 0, dscp0 == 0 but got $pc4,$pc4z" 1>&2
ret=1 ret=1
ok=0 ok=0
...@@ -311,7 +316,7 @@ check_dscp() ...@@ -311,7 +316,7 @@ check_dscp()
ok=0 ok=0
esac esac
if [ $ok -eq 1 ] ;then if [ "$ok" -eq 1 ] ;then
echo "PASS: $what: dscp packet counters match" echo "PASS: $what: dscp packet counters match"
fi fi
} }
...@@ -356,10 +361,12 @@ test_tcp_forwarding_ip() ...@@ -356,10 +361,12 @@ test_tcp_forwarding_ip()
if ! check_transfer "$nsin" "$ns2out" "ns1 -> ns2"; then if ! check_transfer "$nsin" "$ns2out" "ns1 -> ns2"; then
lret=1 lret=1
ret=1
fi fi
if ! check_transfer "$nsin" "$ns1out" "ns1 <- ns2"; then if ! check_transfer "$nsin" "$ns1out" "ns1 <- ns2"; then
lret=1 lret=1
ret=1
fi fi
return $lret return $lret
...@@ -376,7 +383,7 @@ test_tcp_forwarding_set_dscp() ...@@ -376,7 +383,7 @@ test_tcp_forwarding_set_dscp()
{ {
check_dscp "dscp_none" check_dscp "dscp_none"
ip netns exec $nsr1 nft -f - <<EOF ip netns exec "$nsr1" nft -f - <<EOF
table netdev dscpmangle { table netdev dscpmangle {
chain setdscp0 { chain setdscp0 {
type filter hook ingress device "veth0" priority 0; policy accept type filter hook ingress device "veth0" priority 0; policy accept
...@@ -388,12 +395,12 @@ if [ $? -eq 0 ]; then ...@@ -388,12 +395,12 @@ if [ $? -eq 0 ]; then
test_tcp_forwarding_ip "$1" "$2" 10.0.2.99 12345 test_tcp_forwarding_ip "$1" "$2" 10.0.2.99 12345
check_dscp "dscp_ingress" check_dscp "dscp_ingress"
ip netns exec $nsr1 nft delete table netdev dscpmangle ip netns exec "$nsr1" nft delete table netdev dscpmangle
else else
echo "SKIP: Could not load netdev:ingress for veth0" echo "SKIP: Could not load netdev:ingress for veth0"
fi fi
ip netns exec $nsr1 nft -f - <<EOF ip netns exec "$nsr1" nft -f - <<EOF
table netdev dscpmangle { table netdev dscpmangle {
chain setdscp0 { chain setdscp0 {
type filter hook egress device "veth1" priority 0; policy accept type filter hook egress device "veth1" priority 0; policy accept
...@@ -405,14 +412,14 @@ if [ $? -eq 0 ]; then ...@@ -405,14 +412,14 @@ if [ $? -eq 0 ]; then
test_tcp_forwarding_ip "$1" "$2" 10.0.2.99 12345 test_tcp_forwarding_ip "$1" "$2" 10.0.2.99 12345
check_dscp "dscp_egress" check_dscp "dscp_egress"
ip netns exec $nsr1 nft flush table netdev dscpmangle ip netns exec "$nsr1" nft flush table netdev dscpmangle
else else
echo "SKIP: Could not load netdev:egress for veth1" echo "SKIP: Could not load netdev:egress for veth1"
fi fi
# partial. If flowtable really works, then both dscp-is-0 and dscp-is-cs3 # partial. If flowtable really works, then both dscp-is-0 and dscp-is-cs3
# counters should have seen packets (before and after ft offload kicks in). # counters should have seen packets (before and after ft offload kicks in).
ip netns exec $nsr1 nft -a insert rule inet filter forward ip dscp set cs3 ip netns exec "$nsr1" nft -a insert rule inet filter forward ip dscp set cs3
test_tcp_forwarding_ip "$1" "$2" 10.0.2.99 12345 test_tcp_forwarding_ip "$1" "$2" 10.0.2.99 12345
check_dscp "dscp_fwd" check_dscp "dscp_fwd"
} }
...@@ -428,8 +435,8 @@ test_tcp_forwarding_nat() ...@@ -428,8 +435,8 @@ test_tcp_forwarding_nat()
pmtu=$3 pmtu=$3
what=$4 what=$4
if [ $lret -eq 0 ] ; then if [ "$lret" -eq 0 ] ; then
if [ $pmtu -eq 1 ] ;then if [ "$pmtu" -eq 1 ] ;then
check_counters "flow offload for ns1/ns2 with masquerade and pmtu discovery $what" check_counters "flow offload for ns1/ns2 with masquerade and pmtu discovery $what"
else else
echo "PASS: flow offload for ns1/ns2 with masquerade $what" echo "PASS: flow offload for ns1/ns2 with masquerade $what"
...@@ -437,9 +444,9 @@ test_tcp_forwarding_nat() ...@@ -437,9 +444,9 @@ test_tcp_forwarding_nat()
test_tcp_forwarding_ip "$1" "$2" 10.6.6.6 1666 test_tcp_forwarding_ip "$1" "$2" 10.6.6.6 1666
lret=$? lret=$?
if [ $pmtu -eq 1 ] ;then if [ "$pmtu" -eq 1 ] ;then
check_counters "flow offload for ns1/ns2 with dnat and pmtu discovery $what" check_counters "flow offload for ns1/ns2 with dnat and pmtu discovery $what"
elif [ $lret -eq 0 ] ; then elif [ "$lret" -eq 0 ] ; then
echo "PASS: flow offload for ns1/ns2 with dnat $what" echo "PASS: flow offload for ns1/ns2 with dnat $what"
fi fi
fi fi
...@@ -454,25 +461,25 @@ make_file "$nsin" ...@@ -454,25 +461,25 @@ make_file "$nsin"
# Due to MTU mismatch in both directions, all packets (except small packets like pure # Due to MTU mismatch in both directions, all packets (except small packets like pure
# acks) have to be handled by normal forwarding path. Therefore, packet counters # acks) have to be handled by normal forwarding path. Therefore, packet counters
# are not checked. # are not checked.
if test_tcp_forwarding $ns1 $ns2; then if test_tcp_forwarding "$ns1" "$ns2"; then
echo "PASS: flow offloaded for ns1/ns2" echo "PASS: flow offloaded for ns1/ns2"
else else
echo "FAIL: flow offload for ns1/ns2:" 1>&2 echo "FAIL: flow offload for ns1/ns2:" 1>&2
ip netns exec $nsr1 nft list ruleset ip netns exec "$nsr1" nft list ruleset
ret=1 ret=1
fi fi
# delete default route, i.e. ns2 won't be able to reach ns1 and # delete default route, i.e. ns2 won't be able to reach ns1 and
# will depend on ns1 being masqueraded in nsr1. # will depend on ns1 being masqueraded in nsr1.
# expect ns1 has nsr1 address. # expect ns1 has nsr1 address.
ip -net $ns2 route del default via 10.0.2.1 ip -net "$ns2" route del default via 10.0.2.1
ip -net $ns2 route del default via dead:2::1 ip -net "$ns2" route del default via dead:2::1
ip -net $ns2 route add 192.168.10.1 via 10.0.2.1 ip -net "$ns2" route add 192.168.10.1 via 10.0.2.1
# Second test: # Second test:
# Same, but with NAT enabled. Same as in first test: we expect normal forward path # Same, but with NAT enabled. Same as in first test: we expect normal forward path
# to handle most packets. # to handle most packets.
ip netns exec $nsr1 nft -f - <<EOF ip netns exec "$nsr1" nft -f - <<EOF
table ip nat { table ip nat {
chain prerouting { chain prerouting {
type nat hook prerouting priority 0; policy accept; type nat hook prerouting priority 0; policy accept;
...@@ -486,14 +493,14 @@ table ip nat { ...@@ -486,14 +493,14 @@ table ip nat {
} }
EOF EOF
if ! test_tcp_forwarding_set_dscp $ns1 $ns2 0 ""; then if ! test_tcp_forwarding_set_dscp "$ns1" "$ns2" 0 ""; then
echo "FAIL: flow offload for ns1/ns2 with dscp update" 1>&2 echo "FAIL: flow offload for ns1/ns2 with dscp update" 1>&2
exit 0 exit 0
fi fi
if ! test_tcp_forwarding_nat $ns1 $ns2 0 ""; then if ! test_tcp_forwarding_nat "$ns1" "$ns2" 0 ""; then
echo "FAIL: flow offload for ns1/ns2 with NAT" 1>&2 echo "FAIL: flow offload for ns1/ns2 with NAT" 1>&2
ip netns exec $nsr1 nft list ruleset ip netns exec "$nsr1" nft list ruleset
ret=1 ret=1
fi fi
...@@ -501,35 +508,40 @@ fi ...@@ -501,35 +508,40 @@ fi
# Same as second test, but with PMTU discovery enabled. This # Same as second test, but with PMTU discovery enabled. This
# means that we expect the fastpath to handle packets as soon # means that we expect the fastpath to handle packets as soon
# as the endpoints adjust the packet size. # as the endpoints adjust the packet size.
ip netns exec $ns1 sysctl net.ipv4.ip_no_pmtu_disc=0 > /dev/null ip netns exec "$ns1" sysctl net.ipv4.ip_no_pmtu_disc=0 > /dev/null
ip netns exec $ns2 sysctl net.ipv4.ip_no_pmtu_disc=0 > /dev/null ip netns exec "$ns2" sysctl net.ipv4.ip_no_pmtu_disc=0 > /dev/null
# reset counters. # reset counters.
# With pmtu in-place we'll also check that nft counters # With pmtu in-place we'll also check that nft counters
# are lower than file size and packets were forwarded via flowtable layer. # are lower than file size and packets were forwarded via flowtable layer.
# For earlier tests (large mtus), packets cannot be handled via flowtable # For earlier tests (large mtus), packets cannot be handled via flowtable
# (except pure acks and other small packets). # (except pure acks and other small packets).
ip netns exec $nsr1 nft reset counters table inet filter >/dev/null ip netns exec "$nsr1" nft reset counters table inet filter >/dev/null
if ! test_tcp_forwarding_nat $ns1 $ns2 1 ""; then if ! test_tcp_forwarding_nat "$ns1" "$ns2" 1 ""; then
echo "FAIL: flow offload for ns1/ns2 with NAT and pmtu discovery" 1>&2 echo "FAIL: flow offload for ns1/ns2 with NAT and pmtu discovery" 1>&2
ip netns exec $nsr1 nft list ruleset ip netns exec "$nsr1" nft list ruleset
fi fi
# Another test: # Another test:
# Add bridge interface br0 to Router1, with NAT enabled. # Add bridge interface br0 to Router1, with NAT enabled.
ip -net $nsr1 link add name br0 type bridge test_bridge() {
ip -net $nsr1 addr flush dev veth0 if ! ip -net "$nsr1" link add name br0 type bridge 2>/dev/null;then
ip -net $nsr1 link set up dev veth0 echo "SKIP: could not add bridge br0"
ip -net $nsr1 link set veth0 master br0 [ "$ret" -eq 0 ] && ret=$ksft_skip
ip -net $nsr1 addr add 10.0.1.1/24 dev br0 return
ip -net $nsr1 addr add dead:1::1/64 dev br0 nodad fi
ip -net $nsr1 link set up dev br0 ip -net "$nsr1" addr flush dev veth0
ip -net "$nsr1" link set up dev veth0
ip -net "$nsr1" link set veth0 master br0
ip -net "$nsr1" addr add 10.0.1.1/24 dev br0
ip -net "$nsr1" addr add dead:1::1/64 dev br0 nodad
ip -net "$nsr1" link set up dev br0
ip netns exec $nsr1 sysctl net.ipv4.conf.br0.forwarding=1 > /dev/null ip netns exec "$nsr1" sysctl net.ipv4.conf.br0.forwarding=1 > /dev/null
# br0 with NAT enabled. # br0 with NAT enabled.
ip netns exec $nsr1 nft -f - <<EOF ip netns exec "$nsr1" nft -f - <<EOF
flush table ip nat flush table ip nat
table ip nat { table ip nat {
chain prerouting { chain prerouting {
...@@ -544,56 +556,59 @@ table ip nat { ...@@ -544,56 +556,59 @@ table ip nat {
} }
EOF EOF
if ! test_tcp_forwarding_nat $ns1 $ns2 1 "on bridge"; then if ! test_tcp_forwarding_nat "$ns1" "$ns2" 1 "on bridge"; then
echo "FAIL: flow offload for ns1/ns2 with bridge NAT" 1>&2 echo "FAIL: flow offload for ns1/ns2 with bridge NAT" 1>&2
ip netns exec $nsr1 nft list ruleset ip netns exec "$nsr1" nft list ruleset
ret=1 ret=1
fi fi
# Another test: # Another test:
# Add bridge interface br0 to Router1, with NAT and VLAN. # Add bridge interface br0 to Router1, with NAT and VLAN.
ip -net $nsr1 link set veth0 nomaster ip -net "$nsr1" link set veth0 nomaster
ip -net $nsr1 link set down dev veth0 ip -net "$nsr1" link set down dev veth0
ip -net $nsr1 link add link veth0 name veth0.10 type vlan id 10 ip -net "$nsr1" link add link veth0 name veth0.10 type vlan id 10
ip -net $nsr1 link set up dev veth0 ip -net "$nsr1" link set up dev veth0
ip -net $nsr1 link set up dev veth0.10 ip -net "$nsr1" link set up dev veth0.10
ip -net $nsr1 link set veth0.10 master br0 ip -net "$nsr1" link set veth0.10 master br0
ip -net $ns1 addr flush dev eth0 ip -net "$ns1" addr flush dev eth0
ip -net $ns1 link add link eth0 name eth0.10 type vlan id 10 ip -net "$ns1" link add link eth0 name eth0.10 type vlan id 10
ip -net $ns1 link set eth0 up ip -net "$ns1" link set eth0 up
ip -net $ns1 link set eth0.10 up ip -net "$ns1" link set eth0.10 up
ip -net $ns1 addr add 10.0.1.99/24 dev eth0.10 ip -net "$ns1" addr add 10.0.1.99/24 dev eth0.10
ip -net $ns1 route add default via 10.0.1.1 ip -net "$ns1" route add default via 10.0.1.1
ip -net $ns1 addr add dead:1::99/64 dev eth0.10 nodad ip -net "$ns1" addr add dead:1::99/64 dev eth0.10 nodad
if ! test_tcp_forwarding_nat $ns1 $ns2 1 "bridge and VLAN"; then if ! test_tcp_forwarding_nat "$ns1" "$ns2" 1 "bridge and VLAN"; then
echo "FAIL: flow offload for ns1/ns2 with bridge NAT and VLAN" 1>&2 echo "FAIL: flow offload for ns1/ns2 with bridge NAT and VLAN" 1>&2
ip netns exec $nsr1 nft list ruleset ip netns exec "$nsr1" nft list ruleset
ret=1 ret=1
fi fi
# restore test topology (remove bridge and VLAN) # restore test topology (remove bridge and VLAN)
ip -net $nsr1 link set veth0 nomaster ip -net "$nsr1" link set veth0 nomaster
ip -net $nsr1 link set veth0 down ip -net "$nsr1" link set veth0 down
ip -net $nsr1 link set veth0.10 down ip -net "$nsr1" link set veth0.10 down
ip -net $nsr1 link delete veth0.10 type vlan ip -net "$nsr1" link delete veth0.10 type vlan
ip -net $nsr1 link delete br0 type bridge ip -net "$nsr1" link delete br0 type bridge
ip -net $ns1 addr flush dev eth0.10 ip -net "$ns1" addr flush dev eth0.10
ip -net $ns1 link set eth0.10 down ip -net "$ns1" link set eth0.10 down
ip -net $ns1 link set eth0 down ip -net "$ns1" link set eth0 down
ip -net $ns1 link delete eth0.10 type vlan ip -net "$ns1" link delete eth0.10 type vlan
# restore address in ns1 and nsr1 # restore address in ns1 and nsr1
ip -net $ns1 link set eth0 up ip -net "$ns1" link set eth0 up
ip -net $ns1 addr add 10.0.1.99/24 dev eth0 ip -net "$ns1" addr add 10.0.1.99/24 dev eth0
ip -net $ns1 route add default via 10.0.1.1 ip -net "$ns1" route add default via 10.0.1.1
ip -net $ns1 addr add dead:1::99/64 dev eth0 nodad ip -net "$ns1" addr add dead:1::99/64 dev eth0 nodad
ip -net $ns1 route add default via dead:1::1 ip -net "$ns1" route add default via dead:1::1
ip -net $nsr1 addr add 10.0.1.1/24 dev veth0 ip -net "$nsr1" addr add 10.0.1.1/24 dev veth0
ip -net $nsr1 addr add dead:1::1/64 dev veth0 nodad ip -net "$nsr1" addr add dead:1::1/64 dev veth0 nodad
ip -net $nsr1 link set up dev veth0 ip -net "$nsr1" link set up dev veth0
}
test_bridge
KEY_SHA="0x"$(ps -af | sha1sum | cut -d " " -f 1) KEY_SHA="0x"$(ps -af | sha1sum | cut -d " " -f 1)
KEY_AES="0x"$(ps -af | md5sum | cut -d " " -f 1) KEY_AES="0x"$(ps -af | md5sum | cut -d " " -f 1)
...@@ -613,25 +628,25 @@ do_esp() { ...@@ -613,25 +628,25 @@ do_esp() {
local spi_out=$6 local spi_out=$6
local spi_in=$7 local spi_in=$7
ip -net $ns xfrm state add src $remote dst $me proto esp spi $spi_in enc aes $KEY_AES auth sha1 $KEY_SHA mode tunnel sel src $rnet dst $lnet ip -net "$ns" xfrm state add src "$remote" dst "$me" proto esp spi "$spi_in" enc aes "$KEY_AES" auth sha1 "$KEY_SHA" mode tunnel sel src "$rnet" dst "$lnet"
ip -net $ns xfrm state add src $me dst $remote proto esp spi $spi_out enc aes $KEY_AES auth sha1 $KEY_SHA mode tunnel sel src $lnet dst $rnet ip -net "$ns" xfrm state add src "$me" dst "$remote" proto esp spi "$spi_out" enc aes "$KEY_AES" auth sha1 "$KEY_SHA" mode tunnel sel src "$lnet" dst "$rnet"
# to encrypt packets as they go out (includes forwarded packets that need encapsulation) # to encrypt packets as they go out (includes forwarded packets that need encapsulation)
ip -net $ns xfrm policy add src $lnet dst $rnet dir out tmpl src $me dst $remote proto esp mode tunnel priority 1 action allow ip -net "$ns" xfrm policy add src "$lnet" dst "$rnet" dir out tmpl src "$me" dst "$remote" proto esp mode tunnel priority 1 action allow
# to fwd decrypted packets after esp processing: # to fwd decrypted packets after esp processing:
ip -net $ns xfrm policy add src $rnet dst $lnet dir fwd tmpl src $remote dst $me proto esp mode tunnel priority 1 action allow ip -net "$ns" xfrm policy add src "$rnet" dst "$lnet" dir fwd tmpl src "$remote" dst "$me" proto esp mode tunnel priority 1 action allow
} }
do_esp $nsr1 192.168.10.1 192.168.10.2 10.0.1.0/24 10.0.2.0/24 $SPI1 $SPI2 do_esp "$nsr1" 192.168.10.1 192.168.10.2 10.0.1.0/24 10.0.2.0/24 "$SPI1" "$SPI2"
do_esp $nsr2 192.168.10.2 192.168.10.1 10.0.2.0/24 10.0.1.0/24 $SPI2 $SPI1 do_esp "$nsr2" 192.168.10.2 192.168.10.1 10.0.2.0/24 10.0.1.0/24 "$SPI2" "$SPI1"
ip netns exec $nsr1 nft delete table ip nat ip netns exec "$nsr1" nft delete table ip nat
# restore default routes # restore default routes
ip -net $ns2 route del 192.168.10.1 via 10.0.2.1 ip -net "$ns2" route del 192.168.10.1 via 10.0.2.1
ip -net $ns2 route add default via 10.0.2.1 ip -net "$ns2" route add default via 10.0.2.1
ip -net $ns2 route add default via dead:2::1 ip -net "$ns2" route add default via dead:2::1
if test_tcp_forwarding "$ns1" "$ns2"; then if test_tcp_forwarding "$ns1" "$ns2"; then
check_counters "ipsec tunnel mode for ns1/ns2" check_counters "ipsec tunnel mode for ns1/ns2"
...@@ -641,7 +656,7 @@ else ...@@ -641,7 +656,7 @@ else
ip netns exec "$nsr1" cat /proc/net/xfrm_stat 1>&2 ip netns exec "$nsr1" cat /proc/net/xfrm_stat 1>&2
fi fi
if [ x"$1" = x ]; then if [ "$1" = "" ]; then
low=1280 low=1280
mtu=$((65536 - low)) mtu=$((65536 - low))
o=$(((RANDOM%mtu) + low)) o=$(((RANDOM%mtu) + low))
......
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment